﻿Type=StaticCode
Version=3
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Public DB As SQL
	
	' CONSTANTS !!!
	Public BMPFORMAT_PNG As String = "PNG"
	Public BMPFORMAT_JPEG As String = "JPEG"
End Sub

Public Sub DBOpen(Dir As String, FileName As String) As Boolean
	Dim Res As Boolean
	
	Try
		If Not(DB.IsInitialized) Then
			If Not(File.Exists(Dir, FileName)) Then
				DBUtils.CopyDBFromAssets(FileName)
			End If
			DB.Initialize(Dir, FileName, True)
		End If
		Res = True
	Catch
		Log(LastException)
		Res = False
	End Try

	Return Res
End Sub


#Region  Mytable I/O Record 

Public Sub MyTableInsertRecord(Name As String, Bmp As Bitmap, BmpFormat As String)
	Dim mapRecord As Map
	mapRecord.Initialize
	
	mapRecord.Put("_ID", Null)
	mapRecord.Put("Name", Name)
'	mapRecord.Put("Image", ImageFileToByteArray(File.DirAssets, "baby.jpg"))
	mapRecord.Put("Image", ImageToByteArray(Bmp, BmpFormat))
	
	Dim ListOfMaps As List
	ListOfMaps.Initialize
	ListOfMaps.Add(mapRecord)
	
	DBUtils.InsertMaps(DB, "MyTable", ListOfMaps)
	
End Sub

Public Sub MyTableReadRecord(ID As Int) As typMyTableRecord
	
	Dim Query As String
	Dim StringArgs(1) As String
	
	Query = "SELECT * FROM MyTable WHERE _ID = ?"
	StringArgs(0) = ID

	Dim cur As Cursor
	cur = DB.ExecQuery2(Query, StringArgs)

	If cur.RowCount = 0 Then
		Log("No records found.")
		Return Null
	End If

	Dim MyTableRecord As typMyTableRecord
	MyTableRecord.Initialize
	
	cur.Position = 0
	MyTableRecord.ID = cur.GetInt("_ID")
	MyTableRecord.Name = cur.GetString("Name")
	MyTableRecord.Image = BitmapFromBuffer(cur.GetBlob("Image"))
	cur.Close
	
	Return MyTableRecord
End Sub

#End Region

#Region  Bitmaps utilities 
' THESE 3 ROUTINES AND 2 "CONSTANTS" SHOULD BE MOVED IN A SEPARATE SPECIFIC MODULE
'	Public BMPFORMAT_PNG As String = "PNG"
'	Public BMPFORMAT_JPEG As String = "JPEG"

' Converts a Bitmap (PNG or JPEG) to a bytes array
' ATTENTION: it uses ImageFileToByteArray
' ImageFormat can be: "PNG" or "JPEG"
Public Sub ImageToByteArray(Bmp As Bitmap, ImageFormat As String) As Byte()
   Dim Buffer() As Byte

	' Creates a temporary image file
	Dim TempDir, TempFileName As String
	TempDir = File.DirInternal
	TempFileName = "Temp.bmp"
	
	' Saves the bitmap
	Dim out As OutputStream
	out = File.OpenOutput(TempDir, TempFileName, False)
	Bmp.WriteToStream(out, 100, ImageFormat)
	out.Close	

	' Retturns a bytes array from the image file
	Buffer = ImageFileToByteArray(TempDir, TempFileName)
	
	' Deletes the temporary file
	File.Delete(TempDir, TempFileName)
	
	Return Buffer
	
End Sub

'Converts the image file to a bytes array
Public Sub ImageFileToByteArray(Dir As String, ImageFileName As String) As Byte()
    Dim InputStream1 As InputStream
    InputStream1 = File.OpenInput(Dir, ImageFileName)
    Dim OutputStream1 As OutputStream
    OutputStream1.InitializeToBytesArray(1000)
    File.Copy2(InputStream1, OutputStream1)
    Dim Buffer() As Byte
    Buffer = OutputStream1.ToBytesArray
    
	 Return Buffer
End Sub

Public Sub BitmapFromBuffer(Buffer() As Byte) As Bitmap
   Dim In As InputStream
   In.InitializeFromBytesArray(Buffer, 0, Buffer.Length)
   Dim bmp As Bitmap
   bmp.Initialize2(In)
   In.Close
	
	Return bmp
End Sub

#End Region